=== modified file 'NEWS'
--- NEWS	2006-05-12 08:13:36 +0000
+++ NEWS	2006-05-15 22:54:09 +0000
@@ -8,6 +8,8 @@
     * Nicer messages from 'commit' in the case of renames, and correct
       messages when a merge has occured. (Robert Collins, Martin Pool)
 
+    * Fix bug in knits when raising InvalidRevisionId. (#44284, Olaf Conradi)
+
   INTERNALS:
 
     * New public api in InventoryEntry - 'describe_change(old, new)' which

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2006-04-26 18:31:30 +0000
+++ bzrlib/errors.py	2006-05-15 22:54:09 +0000
@@ -134,6 +134,7 @@
 class InvalidRevisionId(BzrNewError):
     """Invalid revision-id {%(revision_id)s} in %(branch)s"""
     def __init__(self, revision_id, branch):
+        # branch can be any string or object with __str__ defined
         BzrNewError.__init__(self)
         self.revision_id = revision_id
         self.branch = branch

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2006-05-03 10:01:43 +0000
+++ bzrlib/knit.py	2006-05-15 22:54:09 +0000
@@ -629,7 +629,7 @@
         assert self.writable, "knit is not opened for write"
         ### FIXME escape. RBC 20060228
         if contains_whitespace(version_id):
-            raise InvalidRevisionId(version_id)
+            raise InvalidRevisionId(version_id, self.filename)
         if self.has_version(version_id):
             raise RevisionAlreadyPresent(version_id, self.filename)
         self._check_lines_not_unicode(lines)

